diff --git tests/cefclient/browser/osr_d3d11_win.h tests/cefclient/browser/osr_d3d11_win.h
new file mode 100644
index 00000000..f1190e38
--- /dev/null
+++ tests/cefclient/browser/osr_d3d11_win.h
@@ -0,0 +1,330 @@
+// Copyright 2018 The Chromium Embedded Framework Authors. All rights reserved.
+// Use of this source code is governed by a BSD-style license that can be found
+// in the LICENSE file.
+//
+// Portions Copyright (c) 2018 Daktronics with the following MIT License:
+//
+// Permission is hereby granted, free of charge, to any person obtaining a copy
+// of this software and associated documentation files (the "Software"), to deal
+// in the Software without restriction, including without limitation the rights
+// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+// copies of the Software, and to permit persons to whom the Software is
+// furnished to do so, subject to the following conditions:
+//
+// The above copyright notice and this permission notice shall be included in
+// all copies or substantial portions of the Software.
+
+#ifndef CEF_TESTS_CEFCLIENT_BROWSER_OSR_D3D11_WIN_H_
+#define CEF_TESTS_CEFCLIENT_BROWSER_OSR_D3D11_WIN_H_
+#pragma once
+
+#include <d3d11_1.h>
+
+#include <memory>
+#include <string>
+#include <vector>
+
+#include "include/base/cef_macros.h"
+
+namespace client {
+namespace d3d11 {
+
+class Composition;
+class Context;
+class Effect;
+class Geometry;
+class SwapChain;
+class Texture2D;
+
+// Basic rect for floats.
+struct Rect {
+  float x;
+  float y;
+  float width;
+  float height;
+};
+
+template <class T>
+class ScopedBinder {
+ public:
+  ScopedBinder(const std::shared_ptr<Context>& ctx,
+               const std::shared_ptr<T>& target)
+      : target_(target) {
+    if (target_) {
+      target_->bind(ctx);
+    }
+  }
+  ~ScopedBinder() {
+    if (target_) {
+      target_->unbind();
+    }
+  }
+
+ private:
+  const std::shared_ptr<T> target_;
+
+  DISALLOW_COPY_AND_ASSIGN(ScopedBinder);
+};
+
+class Context {
+ public:
+  Context(ID3D11DeviceContext*);
+
+  void flush();
+
+  operator ID3D11DeviceContext*() { return ctx_.get(); }
+
+ private:
+  const std::shared_ptr<ID3D11DeviceContext> ctx_;
+};
+
+// Encapsulate a D3D11 Device object.
+class Device {
+ public:
+  Device(ID3D11Device*, ID3D11DeviceContext*);
+
+  static std::shared_ptr<Device> create();
+
+  std::string adapter_name() const;
+
+  operator ID3D11Device*() { return device_.get(); }
+
+  std::shared_ptr<Context> immedidate_context();
+
+  std::shared_ptr<SwapChain> create_swapchain(HWND,
+                                              int width = 0,
+                                              int height = 0);
+
+  std::shared_ptr<Geometry> create_quad(float x,
+                                        float y,
+                                        float width,
+                                        float height,
+                                        bool flip = false);
+
+  std::shared_ptr<Texture2D> create_texture(int width,
+                                            int height,
+                                            DXGI_FORMAT format,
+                                            const void* data,
+                                            size_t row_stride);
+
+  std::shared_ptr<Texture2D> open_shared_texture(void*);
+
+  // Create some basic shaders so we can draw a textured-quad.
+  std::shared_ptr<Effect> create_default_effect();
+
+  std::shared_ptr<Effect> create_effect(const std::string& vertex_code,
+                                        const std::string& vertex_entry,
+                                        const std::string& vertex_model,
+                                        const std::string& pixel_code,
+                                        const std::string& pixel_entry,
+                                        const std::string& pixel_model);
+
+ private:
+  std::shared_ptr<ID3DBlob> compile_shader(const std::string& source_code,
+                                           const std::string& entry_point,
+                                           const std::string& model);
+
+  HMODULE lib_compiler_;
+
+  const std::shared_ptr<ID3D11Device> device_;
+  const std::shared_ptr<Context> ctx_;
+
+  DISALLOW_COPY_AND_ASSIGN(Device);
+};
+
+// Encapsulate a DXGI swapchain for a window.
+class SwapChain {
+ public:
+  SwapChain(IDXGISwapChain*,
+            ID3D11RenderTargetView*,
+            ID3D11SamplerState*,
+            ID3D11BlendState*);
+
+  void bind(const std::shared_ptr<Context>& ctx);
+  void unbind();
+
+  void clear(float red, float green, float blue, float alpha);
+
+  void present(int sync_interval);
+  void resize(int width, int height);
+
+  int width() const { return width_; }
+  int height() const { return height_; }
+
+ private:
+  const std::shared_ptr<ID3D11SamplerState> sampler_;
+  const std::shared_ptr<ID3D11BlendState> blender_;
+  const std::shared_ptr<IDXGISwapChain> swapchain_;
+  std::shared_ptr<ID3D11RenderTargetView> rtv_;
+  std::shared_ptr<Context> ctx_;
+  int width_;
+  int height_;
+
+  DISALLOW_COPY_AND_ASSIGN(SwapChain);
+};
+
+class Texture2D {
+ public:
+  Texture2D(ID3D11Texture2D* tex, ID3D11ShaderResourceView* srv);
+
+  void bind(std::shared_ptr<Context> const& ctx);
+  void unbind();
+
+  uint32_t width() const;
+  uint32_t height() const;
+  DXGI_FORMAT format() const;
+
+  bool has_mutex() const;
+
+  bool lock_key(uint64_t key, uint32_t timeout_ms);
+  void unlock_key(uint64_t key);
+
+  void* share_handle() const;
+
+  void copy_from(const std::shared_ptr<Texture2D>&);
+
+ private:
+  HANDLE share_handle_;
+
+  const std::shared_ptr<ID3D11Texture2D> texture_;
+  const std::shared_ptr<ID3D11ShaderResourceView> srv_;
+  std::shared_ptr<IDXGIKeyedMutex> keyed_mutex_;
+  std::shared_ptr<Context> ctx_;
+
+  DISALLOW_COPY_AND_ASSIGN(Texture2D);
+};
+
+class Effect {
+ public:
+  Effect(ID3D11VertexShader* vsh,
+         ID3D11PixelShader* psh,
+         ID3D11InputLayout* layout);
+
+  void bind(const std::shared_ptr<Context>& ctx);
+  void unbind();
+
+ private:
+  const std::shared_ptr<ID3D11VertexShader> vsh_;
+  const std::shared_ptr<ID3D11PixelShader> psh_;
+  const std::shared_ptr<ID3D11InputLayout> layout_;
+  std::shared_ptr<Context> ctx_;
+
+  DISALLOW_COPY_AND_ASSIGN(Effect);
+};
+
+class Geometry {
+ public:
+  Geometry(D3D_PRIMITIVE_TOPOLOGY primitive,
+           uint32_t vertices,
+           uint32_t stride,
+           ID3D11Buffer*);
+
+  void bind(const std::shared_ptr<Context>& ctx);
+  void unbind();
+
+  void draw();
+
+ private:
+  D3D_PRIMITIVE_TOPOLOGY primitive_;
+  uint32_t vertices_;
+  uint32_t stride_;
+  const std::shared_ptr<ID3D11Buffer> buffer_;
+  std::shared_ptr<Context> ctx_;
+
+  DISALLOW_COPY_AND_ASSIGN(Geometry);
+};
+
+// Abstraction for a 2D layer within a composition.
+class Layer {
+ public:
+  Layer(const std::shared_ptr<Device>& device, bool flip);
+  virtual ~Layer();
+
+  void attach(const std::shared_ptr<Composition>&);
+
+  // Uses normalized 0-1.0 coordinates.
+  virtual void move(float x, float y, float width, float height);
+
+  virtual void tick(double t);
+  virtual void render(const std::shared_ptr<Context>& ctx) = 0;
+
+  Rect bounds() const;
+
+  std::shared_ptr<Composition> composition() const;
+
+ protected:
+  // Helper method for derived classes to draw a textured-quad.
+  void render_texture(const std::shared_ptr<Context>& ctx,
+                      const std::shared_ptr<Texture2D>& texture);
+
+  const std::shared_ptr<Device> device_;
+  const bool flip_;
+
+  Rect bounds_;
+  std::shared_ptr<Geometry> geometry_;
+  std::shared_ptr<Effect> effect_;
+
+ private:
+  std::weak_ptr<Composition> composition_;
+
+  DISALLOW_COPY_AND_ASSIGN(Layer);
+};
+
+// A collection of layers. Will render 1-N layers to a D3D11 device.
+class Composition : public std::enable_shared_from_this<Composition> {
+ public:
+  Composition(const std::shared_ptr<Device>& device,
+              int width = 0,
+              int height = 0);
+
+  int width() const { return width_; }
+  int height() const { return height_; }
+
+  double fps() const;
+  double time() const;
+
+  bool is_vsync() const;
+
+  void tick(double);
+  void render(const std::shared_ptr<Context>&);
+
+  void add_layer(const std::shared_ptr<Layer>& layer);
+  bool remove_layer(const std::shared_ptr<Layer>& layer);
+  void resize(bool vsync, int width, int height);
+
+ private:
+  int width_;
+  int height_;
+  uint32_t frame_;
+  int64_t fps_start_;
+  double fps_;
+  double time_;
+  bool vsync_;
+
+  const std::shared_ptr<Device> device_;
+  std::vector<std::shared_ptr<Layer>> layers_;
+
+  DISALLOW_COPY_AND_ASSIGN(Composition);
+};
+
+class FrameBuffer {
+ public:
+  explicit FrameBuffer(const std::shared_ptr<Device>& device);
+
+  // Called in response to CEF's OnAcceleratedPaint notification.
+  void on_paint(void* shared_handle);
+
+  // Returns what should be considered the front buffer.
+  std::shared_ptr<Texture2D> texture() const { return shared_buffer_; }
+
+ private:
+  const std::shared_ptr<Device> device_;
+  std::shared_ptr<Texture2D> shared_buffer_;
+
+  DISALLOW_COPY_AND_ASSIGN(FrameBuffer);
+};
+
+}  // namespace d3d11
+}  // namespace client
+
+#endif  // CEF_TESTS_CEFCLIENT_BROWSER_OSR_D3D11_WIN_H_
diff --git tests/cefclient/browser/osr_render_handler_win.cc tests/cefclient/browser/osr_render_handler_win.cc
new file mode 100644
index 00000000..8fa9b169
--- /dev/null
+++ tests/cefclient/browser/osr_render_handler_win.cc
@@ -0,0 +1,83 @@
+// Copyright 2018 The Chromium Embedded Framework Authors. All rights
+// reserved. Use of this source code is governed by a BSD-style license that
+// can be found in the LICENSE file.
+
+#include "tests/cefclient/browser/osr_render_handler_win.h"
+
+#include "include/base/cef_bind.h"
+#include "include/wrapper/cef_closure_task.h"
+#include "include/wrapper/cef_helpers.h"
+#include "tests/shared/browser/util_win.h"
+
+namespace client {
+
+OsrRenderHandlerWin::OsrRenderHandlerWin(const OsrRendererSettings& settings,
+                                         HWND hwnd)
+    : settings_(settings),
+      hwnd_(hwnd),
+      begin_frame_pending_(false),
+      weak_factory_(this) {
+  CEF_REQUIRE_UI_THREAD();
+  DCHECK(hwnd_);
+}
+
+OsrRenderHandlerWin::~OsrRenderHandlerWin() {
+  CEF_REQUIRE_UI_THREAD();
+}
+
+void OsrRenderHandlerWin::SetBrowser(CefRefPtr<CefBrowser> browser) {
+  CEF_REQUIRE_UI_THREAD();
+  browser_ = browser;
+  if (browser_ && settings_.external_begin_frame_enabled) {
+    // Start the BeginFrame timer.
+    Invalidate();
+  }
+}
+
+void OsrRenderHandlerWin::Invalidate() {
+  CEF_REQUIRE_UI_THREAD();
+  if (begin_frame_pending_) {
+    // The timer is already running.
+    return;
+  }
+
+  // Trigger the BeginFrame timer.
+  CHECK_GT(settings_.begin_frame_rate, 0);
+  const float delay_us = (1.0 / double(settings_.begin_frame_rate)) * 1000000.0;
+  TriggerBeginFrame(0, delay_us);
+}
+
+void OsrRenderHandlerWin::TriggerBeginFrame(uint64_t last_time_us,
+                                            float delay_us) {
+  if (begin_frame_pending_ && !settings_.external_begin_frame_enabled) {
+    // Render immediately and then wait for the next call to Invalidate() or
+    // On[Accelerated]Paint().
+    begin_frame_pending_ = false;
+    Render();
+    return;
+  }
+
+  const auto now = GetTimeNow();
+  float offset = now - last_time_us;
+  if (offset > delay_us) {
+    offset = delay_us;
+  }
+
+  if (!begin_frame_pending_) {
+    begin_frame_pending_ = true;
+  }
+
+  // Trigger again after the necessary delay to maintain the desired frame rate.
+  CefPostDelayedTask(TID_UI,
+                     base::Bind(&OsrRenderHandlerWin::TriggerBeginFrame,
+                                weak_factory_.GetWeakPtr(), now, delay_us),
+                     int64(offset / 1000.0));
+
+  if (settings_.external_begin_frame_enabled && browser_) {
+    // We're running the BeginFrame timer. Trigger rendering via
+    // On[Accelerated]Paint().
+    browser_->GetHost()->SendExternalBeginFrame();
+  }
+}
+
+}  // namespace client
diff --git tests/cefclient/browser/osr_render_handler_win.h tests/cefclient/browser/osr_render_handler_win.h
new file mode 100644
index 00000000..4eee0249
--- /dev/null
+++ tests/cefclient/browser/osr_render_handler_win.h
@@ -0,0 +1,82 @@
+// Copyright 2018 The Chromium Embedded Framework Authors. All rights
+// reserved. Use of this source code is governed by a BSD-style license that
+// can be found in the LICENSE file.
+
+#ifndef CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_H_
+#define CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_H_
+#pragma once
+
+#include "include/base/cef_weak_ptr.h"
+#include "include/cef_render_handler.h"
+#include "tests/cefclient/browser/osr_renderer_settings.h"
+
+namespace client {
+
+// Abstract base class for implementing OSR rendering with different backends on
+// Windows. Methods are only called on the UI thread.
+class OsrRenderHandlerWin {
+ public:
+  OsrRenderHandlerWin(const OsrRendererSettings& settings, HWND hwnd);
+  virtual ~OsrRenderHandlerWin();
+
+  void SetBrowser(CefRefPtr<CefBrowser> browser);
+
+  // Rotate the texture based on mouse events.
+  virtual void SetSpin(float spinX, float spinY) = 0;
+  virtual void IncrementSpin(float spinDX, float spinDY) = 0;
+
+  // Popup hit testing.
+  virtual bool IsOverPopupWidget(int x, int y) const = 0;
+  virtual int GetPopupXOffset() const = 0;
+  virtual int GetPopupYOffset() const = 0;
+
+  // CefRenderHandler callbacks.
+  virtual void OnPopupShow(CefRefPtr<CefBrowser> browser, bool show) = 0;
+  // |rect| must be in pixel coordinates.
+  virtual void OnPopupSize(CefRefPtr<CefBrowser> browser,
+                           const CefRect& rect) = 0;
+
+  // Used when not rendering with shared textures.
+  virtual void OnPaint(CefRefPtr<CefBrowser> browser,
+                       CefRenderHandler::PaintElementType type,
+                       const CefRenderHandler::RectList& dirtyRects,
+                       const void* buffer,
+                       int width,
+                       int height) = 0;
+
+  // Used when rendering with shared textures.
+  virtual void OnAcceleratedPaint(CefRefPtr<CefBrowser> browser,
+                                  CefRenderHandler::PaintElementType type,
+                                  const CefRenderHandler::RectList& dirtyRects,
+                                  void* share_handle) = 0;
+
+  bool send_begin_frame() const {
+    return settings_.external_begin_frame_enabled;
+  }
+  HWND hwnd() const { return hwnd_; }
+
+ protected:
+  // Called to trigger the BeginFrame timer.
+  void Invalidate();
+
+  // Called by the BeginFrame timer.
+  virtual void Render() = 0;
+
+ private:
+  void TriggerBeginFrame(uint64_t last_time_us, float delay_us);
+
+  // The below members are only accessed on the UI thread.
+  const OsrRendererSettings settings_;
+  const HWND hwnd_;
+  bool begin_frame_pending_;
+  CefRefPtr<CefBrowser> browser_;
+
+  // Must be the last member.
+  base::WeakPtrFactory<OsrRenderHandlerWin> weak_factory_;
+
+  DISALLOW_COPY_AND_ASSIGN(OsrRenderHandlerWin);
+};
+
+}  // namespace client
+
+#endif  // CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_H_
diff --git tests/cefclient/browser/osr_render_handler_win_d3d11.cc tests/cefclient/browser/osr_render_handler_win_d3d11.cc
new file mode 100644
index 00000000..bee90359
--- /dev/null
+++ tests/cefclient/browser/osr_render_handler_win_d3d11.cc
@@ -0,0 +1,218 @@
+// Copyright 2018 The Chromium Embedded Framework Authors. All rights
+// reserved. Use of this source code is governed by a BSD-style license that
+// can be found in the LICENSE file.
+
+#include "tests/cefclient/browser/osr_render_handler_win_d3d11.h"
+
+#include "include/base/cef_bind.h"
+#include "include/wrapper/cef_closure_task.h"
+#include "include/wrapper/cef_helpers.h"
+#include "tests/cefclient/browser/main_context.h"
+#include "tests/shared/browser/util_win.h"
+
+namespace client {
+
+BrowserLayer::BrowserLayer(const std::shared_ptr<d3d11::Device>& device)
+    : d3d11::Layer(device, true /* flip */) {
+  frame_buffer_ = std::make_shared<d3d11::FrameBuffer>(device_);
+}
+
+void BrowserLayer::render(const std::shared_ptr<d3d11::Context>& ctx) {
+  // Use the base class method to draw our texture.
+  render_texture(ctx, frame_buffer_->texture());
+}
+
+void BrowserLayer::on_paint(void* share_handle) {
+  frame_buffer_->on_paint(share_handle);
+}
+
+std::pair<uint32_t, uint32_t> BrowserLayer::texture_size() const {
+  const auto texture = frame_buffer_->texture();
+  return std::make_pair(texture->width(), texture->height());
+}
+
+PopupLayer::PopupLayer(const std::shared_ptr<d3d11::Device>& device)
+    : BrowserLayer(device) {}
+
+void PopupLayer::set_bounds(const CefRect& bounds) {
+  const auto comp = composition();
+  if (!comp)
+    return;
+
+  const auto outer_width = comp->width();
+  const auto outer_height = comp->height();
+  if (outer_width == 0 || outer_height == 0)
+    return;
+
+  original_bounds_ = bounds;
+  bounds_ = bounds;
+
+  // If x or y are negative, move them to 0.
+  if (bounds_.x < 0)
+    bounds_.x = 0;
+  if (bounds_.y < 0)
+    bounds_.y = 0;
+  // If popup goes outside the view, try to reposition origin
+  if (bounds_.x + bounds_.width > outer_width)
+    bounds_.x = outer_width - bounds_.width;
+  if (bounds_.y + bounds_.height > outer_height)
+    bounds_.y = outer_height - bounds_.height;
+  // If x or y became negative, move them to 0 again.
+  if (bounds_.x < 0)
+    bounds_.x = 0;
+  if (bounds_.y < 0)
+    bounds_.y = 0;
+
+  const auto x = bounds_.x / float(outer_width);
+  const auto y = bounds_.y / float(outer_height);
+  const auto w = bounds_.width / float(outer_width);
+  const auto h = bounds_.height / float(outer_height);
+  move(x, y, w, h);
+}
+
+OsrRenderHandlerWinD3D11::OsrRenderHandlerWinD3D11(
+    const OsrRendererSettings& settings,
+    HWND hwnd)
+    : OsrRenderHandlerWin(settings, hwnd), start_time_(0) {}
+
+bool OsrRenderHandlerWinD3D11::Initialize(CefRefPtr<CefBrowser> browser,
+                                          int width,
+                                          int height) {
+  CEF_REQUIRE_UI_THREAD();
+
+  // Retrieve the shared D3D11 device instance.
+  device_ = MainContext::Get()->GetD3D11Device();
+  DCHECK(device_);
+  if (!device_)
+    return false;
+
+  // Create a D3D11 swapchain for the window.
+  swap_chain_ = device_->create_swapchain(hwnd());
+  DCHECK(swap_chain_);
+  if (!swap_chain_)
+    return false;
+
+  // Create the browser layer.
+  browser_layer_ = std::make_shared<BrowserLayer>(device_);
+
+  // Set up the composition.
+  composition_ = std::make_shared<d3d11::Composition>(device_, width, height);
+  composition_->add_layer(browser_layer_);
+
+  // Size to the whole composition.
+  browser_layer_->move(0.0f, 0.0f, 1.0f, 1.0f);
+
+  start_time_ = GetTimeNow();
+
+  SetBrowser(browser);
+  return true;
+}
+
+void OsrRenderHandlerWinD3D11::SetSpin(float spinX, float spinY) {
+  CEF_REQUIRE_UI_THREAD();
+  // Spin support is not implemented.
+}
+
+void OsrRenderHandlerWinD3D11::IncrementSpin(float spinDX, float spinDY) {
+  CEF_REQUIRE_UI_THREAD();
+  // Spin support is not implemented.
+}
+
+bool OsrRenderHandlerWinD3D11::IsOverPopupWidget(int x, int y) const {
+  CEF_REQUIRE_UI_THREAD();
+  return popup_layer_ && popup_layer_->contains(x, y);
+}
+
+int OsrRenderHandlerWinD3D11::GetPopupXOffset() const {
+  CEF_REQUIRE_UI_THREAD();
+  if (popup_layer_)
+    return popup_layer_->xoffset();
+  return 0;
+}
+
+int OsrRenderHandlerWinD3D11::GetPopupYOffset() const {
+  CEF_REQUIRE_UI_THREAD();
+  if (popup_layer_)
+    return popup_layer_->yoffset();
+  return 0;
+}
+
+void OsrRenderHandlerWinD3D11::OnPopupShow(CefRefPtr<CefBrowser> browser,
+                                           bool show) {
+  CEF_REQUIRE_UI_THREAD();
+
+  if (show) {
+    DCHECK(!popup_layer_);
+
+    // Create a new layer.
+    popup_layer_ = std::make_shared<PopupLayer>(device_);
+    composition_->add_layer(popup_layer_);
+  } else {
+    DCHECK(popup_layer_);
+
+    composition_->remove_layer(popup_layer_);
+    popup_layer_ = nullptr;
+
+    Render();
+  }
+}
+
+void OsrRenderHandlerWinD3D11::OnPopupSize(CefRefPtr<CefBrowser> browser,
+                                           const CefRect& rect) {
+  CEF_REQUIRE_UI_THREAD();
+  popup_layer_->set_bounds(rect);
+}
+
+void OsrRenderHandlerWinD3D11::OnPaint(
+    CefRefPtr<CefBrowser> browser,
+    CefRenderHandler::PaintElementType type,
+    const CefRenderHandler::RectList& dirtyRects,
+    const void* buffer,
+    int width,
+    int height) {
+  // Not used with this implementation.
+  NOTREACHED();
+}
+
+void OsrRenderHandlerWinD3D11::OnAcceleratedPaint(
+    CefRefPtr<CefBrowser> browser,
+    CefRenderHandler::PaintElementType type,
+    const CefRenderHandler::RectList& dirtyRects,
+    void* share_handle) {
+  CEF_REQUIRE_UI_THREAD();
+
+  if (type == PET_POPUP) {
+    popup_layer_->on_paint(share_handle);
+  } else {
+    browser_layer_->on_paint(share_handle);
+  }
+
+  Render();
+}
+
+void OsrRenderHandlerWinD3D11::Render() {
+  // Update composition + layers based on time.
+  const auto t = (GetTimeNow() - start_time_) / 1000000.0;
+  composition_->tick(t);
+
+  auto ctx = device_->immedidate_context();
+  swap_chain_->bind(ctx);
+
+  const auto texture_size = browser_layer_->texture_size();
+
+  // Resize the composition and swap chain to match the texture if necessary.
+  composition_->resize(!send_begin_frame(), texture_size.first,
+                       texture_size.second);
+  swap_chain_->resize(texture_size.first, texture_size.second);
+
+  // Clear the render target.
+  swap_chain_->clear(0.0f, 0.0f, 1.0f, 1.0f);
+
+  // Render the scene.
+  composition_->render(ctx);
+
+  // Present to window.
+  swap_chain_->present(send_begin_frame() ? 0 : 1);
+}
+
+}  // namespace client
diff --git tests/cefclient/browser/osr_render_handler_win_d3d11.h tests/cefclient/browser/osr_render_handler_win_d3d11.h
new file mode 100644
index 00000000..a72b1dda
--- /dev/null
+++ tests/cefclient/browser/osr_render_handler_win_d3d11.h
@@ -0,0 +1,90 @@
+// Copyright 2018 The Chromium Embedded Framework Authors. All rights
+// reserved. Use of this source code is governed by a BSD-style license that
+// can be found in the LICENSE file.
+
+#ifndef CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_D3D11_H_
+#define CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_D3D11_H_
+#pragma once
+
+#include "tests/cefclient/browser/osr_d3d11_win.h"
+#include "tests/cefclient/browser/osr_render_handler_win.h"
+#include "tests/cefclient/browser/osr_renderer_settings.h"
+
+namespace client {
+
+class BrowserLayer : public d3d11::Layer {
+ public:
+  explicit BrowserLayer(const std::shared_ptr<d3d11::Device>& device);
+
+  void render(const std::shared_ptr<d3d11::Context>& ctx) OVERRIDE;
+
+  void on_paint(void* share_handle);
+
+  // After calling on_paint() we can query the texture size.
+  std::pair<uint32_t, uint32_t> texture_size() const;
+
+ private:
+  std::shared_ptr<d3d11::FrameBuffer> frame_buffer_;
+
+  DISALLOW_COPY_AND_ASSIGN(BrowserLayer);
+};
+
+class PopupLayer : public BrowserLayer {
+ public:
+  explicit PopupLayer(const std::shared_ptr<d3d11::Device>& device);
+
+  void set_bounds(const CefRect& bounds);
+
+  bool contains(int x, int y) const { return bounds_.Contains(x, y); }
+  int xoffset() const { return original_bounds_.x - bounds_.x; }
+  int yoffset() const { return original_bounds_.y - bounds_.y; }
+
+ private:
+  CefRect original_bounds_;
+  CefRect bounds_;
+
+  DISALLOW_COPY_AND_ASSIGN(PopupLayer);
+};
+
+class OsrRenderHandlerWinD3D11 : public OsrRenderHandlerWin {
+ public:
+  OsrRenderHandlerWinD3D11(const OsrRendererSettings& settings, HWND hwnd);
+
+  // Must be called immediately after object creation.
+  // May fail if D3D11 cannot be initialized.
+  bool Initialize(CefRefPtr<CefBrowser> browser, int width, int height);
+
+  void SetSpin(float spinX, float spinY) OVERRIDE;
+  void IncrementSpin(float spinDX, float spinDY) OVERRIDE;
+  bool IsOverPopupWidget(int x, int y) const OVERRIDE;
+  int GetPopupXOffset() const OVERRIDE;
+  int GetPopupYOffset() const OVERRIDE;
+  void OnPopupShow(CefRefPtr<CefBrowser> browser, bool show) OVERRIDE;
+  void OnPopupSize(CefRefPtr<CefBrowser> browser, const CefRect& rect) OVERRIDE;
+  void OnPaint(CefRefPtr<CefBrowser> browser,
+               CefRenderHandler::PaintElementType type,
+               const CefRenderHandler::RectList& dirtyRects,
+               const void* buffer,
+               int width,
+               int height) OVERRIDE;
+  void OnAcceleratedPaint(CefRefPtr<CefBrowser> browser,
+                          CefRenderHandler::PaintElementType type,
+                          const CefRenderHandler::RectList& dirtyRects,
+                          void* share_handle) OVERRIDE;
+
+ private:
+  void Render() OVERRIDE;
+
+  uint64_t start_time_;
+  std::shared_ptr<d3d11::Device> device_;
+  std::shared_ptr<d3d11::SwapChain> swap_chain_;
+  std::shared_ptr<d3d11::Composition> composition_;
+  std::shared_ptr<BrowserLayer> browser_layer_;
+  std::shared_ptr<PopupLayer> popup_layer_;
+
+  DISALLOW_COPY_AND_ASSIGN(OsrRenderHandlerWinD3D11);
+};
+
+}  // namespace client
+
+#endif  // CEF_TESTS_CEFCLIENT_BROWSER_OSR_RENDER_HANDLER_WIN_D3D11_H_
diff --git tests/cefclient/browser/osr_render_handler_win_gl.cc tests/cefclient/browser/osr_render_handler_win_gl.cc
new file mode 100644
index 00000000..6bfe1ea3
--- /dev/null
+++ tests/cefclient/browser/osr_render_handler_win_gl.cc
@@ -0,0 +1,201 @@
+// Copyright 2018 The Chromium Embedded Framework Authors. All rights
+// reserved. Use of this source code is governed by a BSD-style license that
+// can be found in the LICENSE file.
+
+#include "tests/cefclient/browser/osr_render_handler_win_gl.h"
+
+#include "include/base/cef_bind.h"
+#include "include/wrapper/cef_closure_task.h"
+#include "include/wrapper/cef_helpers.h"
+#include "tests/shared/browser/util_win.h"
+
+namespace client {
+
+namespace {
+
+// Helper that calls wglMakeCurrent.
+class ScopedGLContext {
+ public:
+  ScopedGLContext(HDC hdc, HGLRC hglrc, bool swap_buffers)
+      : hdc_(hdc), swap_buffers_(swap_buffers) {
+    BOOL result = wglMakeCurrent(hdc, hglrc);
+    ALLOW_UNUSED_LOCAL(result);
+    DCHECK(result);
+  }
+  ~ScopedGLContext() {
+    BOOL result = wglMakeCurrent(NULL, NULL);
+    DCHECK(result);
+    if (swap_buffers_) {
+      result = SwapBuffers(hdc_);
+      DCHECK(result);
+    }
+  }
+
+ private:
+  const HDC hdc_;
+  const bool swap_buffers_;
+};
+
+}  // namespace
+
+OsrRenderHandlerWinGL::OsrRenderHandlerWinGL(
+    const OsrRendererSettings& settings,
+    HWND hwnd)
+    : OsrRenderHandlerWin(settings, hwnd),
+      renderer_(settings),
+      hdc_(NULL),
+      hrc_(NULL),
+      painting_popup_(false) {}
+
+void OsrRenderHandlerWinGL::Initialize(CefRefPtr<CefBrowser> browser) {
+  CEF_REQUIRE_UI_THREAD();
+  SetBrowser(browser);
+}
+
+OsrRenderHandlerWinGL::~OsrRenderHandlerWinGL() {
+  CEF_REQUIRE_UI_THREAD();
+  DisableGL();
+}
+
+void OsrRenderHandlerWinGL::SetSpin(float spinX, float spinY) {
+  CEF_REQUIRE_UI_THREAD();
+  renderer_.SetSpin(spinX, spinY);
+  Invalidate();
+}
+
+void OsrRenderHandlerWinGL::IncrementSpin(float spinDX, float spinDY) {
+  CEF_REQUIRE_UI_THREAD();
+  renderer_.IncrementSpin(spinDX, spinDY);
+  Invalidate();
+}
+
+bool OsrRenderHandlerWinGL::IsOverPopupWidget(int x, int y) const {
+  CEF_REQUIRE_UI_THREAD();
+  const CefRect& rc = renderer_.popup_rect();
+  int popup_right = rc.x + rc.width;
+  int popup_bottom = rc.y + rc.height;
+  return (x >= rc.x) && (x < popup_right) && (y >= rc.y) && (y < popup_bottom);
+}
+
+int OsrRenderHandlerWinGL::GetPopupXOffset() const {
+  CEF_REQUIRE_UI_THREAD();
+  return renderer_.original_popup_rect().x - renderer_.popup_rect().x;
+}
+
+int OsrRenderHandlerWinGL::GetPopupYOffset() const {
+  CEF_REQUIRE_UI_THREAD();
+  return renderer_.original_popup_rect().y - renderer_.popup_rect().y;
+}
+
+void OsrRenderHandlerWinGL::OnPopupShow(CefRefPtr<CefBrowser> browser,
+                                        bool show) {
+  CEF_REQUIRE_UI_THREAD();
+
+  if (!show) {
+    renderer_.ClearPopupRects();
+    browser->GetHost()->Invalidate(PET_VIEW);
+  }
+
+  renderer_.OnPopupShow(browser, show);
+}
+
+void OsrRenderHandlerWinGL::OnPopupSize(CefRefPtr<CefBrowser> browser,
+                                        const CefRect& rect) {
+  CEF_REQUIRE_UI_THREAD();
+  renderer_.OnPopupSize(browser, rect);
+}
+
+void OsrRenderHandlerWinGL::OnPaint(
+    CefRefPtr<CefBrowser> browser,
+    CefRenderHandler::PaintElementType type,
+    const CefRenderHandler::RectList& dirtyRects,
+    const void* buffer,
+    int width,
+    int height) {
+  CEF_REQUIRE_UI_THREAD();
+
+  if (painting_popup_) {
+    renderer_.OnPaint(browser, type, dirtyRects, buffer, width, height);
+    return;
+  }
+  if (!hdc_) {
+    EnableGL();
+  }
+
+  ScopedGLContext scoped_gl_context(hdc_, hrc_, true);
+  renderer_.OnPaint(browser, type, dirtyRects, buffer, width, height);
+  if (type == PET_VIEW && !renderer_.popup_rect().IsEmpty()) {
+    painting_popup_ = true;
+    browser->GetHost()->Invalidate(PET_POPUP);
+    painting_popup_ = false;
+  }
+  renderer_.Render();
+}
+
+void OsrRenderHandlerWinGL::OnAcceleratedPaint(
+    CefRefPtr<CefBrowser> browser,
+    CefRenderHandler::PaintElementType type,
+    const CefRenderHandler::RectList& dirtyRects,
+    void* share_handle) {
+  // Not used with this implementation.
+  NOTREACHED();
+}
+
+void OsrRenderHandlerWinGL::Render() {
+  if (!hdc_) {
+    EnableGL();
+  }
+
+  ScopedGLContext scoped_gl_context(hdc_, hrc_, true);
+  renderer_.Render();
+}
+
+void OsrRenderHandlerWinGL::EnableGL() {
+  PIXELFORMATDESCRIPTOR pfd;
+  int format;
+
+  // Get the device context.
+  hdc_ = GetDC(hwnd());
+
+  // Set the pixel format for the DC.
+  ZeroMemory(&pfd, sizeof(pfd));
+  pfd.nSize = sizeof(pfd);
+  pfd.nVersion = 1;
+  pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
+  pfd.iPixelType = PFD_TYPE_RGBA;
+  pfd.cColorBits = 24;
+  pfd.cDepthBits = 16;
+  pfd.iLayerType = PFD_MAIN_PLANE;
+  format = ChoosePixelFormat(hdc_, &pfd);
+  SetPixelFormat(hdc_, format, &pfd);
+
+  // Create and enable the render context.
+  hrc_ = wglCreateContext(hdc_);
+
+  ScopedGLContext scoped_gl_context(hdc_, hrc_, false);
+  renderer_.Initialize();
+}
+
+void OsrRenderHandlerWinGL::DisableGL() {
+  if (!hdc_) {
+    return;
+  }
+
+  {
+    ScopedGLContext scoped_gl_context(hdc_, hrc_, false);
+    renderer_.Cleanup();
+  }
+
+  if (IsWindow(hwnd())) {
+    // wglDeleteContext will make the context not current before deleting it.
+    BOOL result = wglDeleteContext(hrc_);
+    ALLOW_UNUSED_LOCAL(result);
+    DCHECK(result);
+    ReleaseDC(hwnd(), hdc_);
+  }
+
+  hdc_ = NULL;
+  hrc_ = NULL;
+}
+
+}  // namespace client
